/**
* 
* @author José Rojel
* 
*	Esta clase genera los elementos de Swing que se mostrarán en la
*	pantalla de bienvenida.
*	
*/

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

public class OpeningPanel extends JPanel {
	/**
	 * 
	 */

	public OpeningPanel(JPanel cards) {
				
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		CardLayout card_changer = (CardLayout)(cards.getLayout());
		
		// Mensaje de Bienvenida
		JLabel welcome_text = new JLabel("Bienvenido a TaxiTrack!");
		welcome_text.setFont(new Font("Dialog", Font.BOLD, 17));
		welcome_text.setHorizontalAlignment(SwingConstants.CENTER);
		welcome_text.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		// Botones principales
		
		// Botón de Registro
		JButton registerer_btn = new JButton("Registrar");
		registerer_btn.setAlignmentX(Component.CENTER_ALIGNMENT);
		registerer_btn.setFont(new Font("Dialog", Font.BOLD, 14));
		registerer_btn.setPreferredSize(new Dimension(140, 40));
		registerer_btn.setMinimumSize(new Dimension(140, 40));
		registerer_btn.setMaximumSize(new Dimension(140, 40));
		registerer_btn.addActionListener(new ActionListener() {
			
			// Evento para el botón de registro
	        @Override
	        public void actionPerformed(ActionEvent arg0) {
	        	card_changer.show(cards, "Panel de Registro");
	        }
	    });
	
		// Evento de Historial
		JButton shower_btn = new JButton("Ver Historial");
		shower_btn.setAlignmentX(Component.CENTER_ALIGNMENT);
		shower_btn.setFont(new Font("Dialog", Font.BOLD, 14));
		shower_btn.setPreferredSize(new Dimension(140, 40));
		shower_btn.setMinimumSize(new Dimension(140, 40));
		shower_btn.setMaximumSize(new Dimension(140, 40));
		shower_btn.addActionListener(new ActionListener() {
			
			// Evento para el botón de registro
	        @Override
	        public void actionPerformed(ActionEvent arg0) {
	        	card_changer.show(cards, "Panel de Gráficos");
	        }
	    });
		
		// Creador
		JLabel maker = new JLabel("v1.0 Creada por José Rojel ");
		maker.setFont(new Font("Dialog", Font.ITALIC, 10));
		maker.setHorizontalAlignment(SwingConstants.CENTER);
		maker.setAlignmentX(Component.RIGHT_ALIGNMENT);
		
		// Agregar elementos al Panel

		// 20 Pixeles vacios al principio
		this.add(Box.createRigidArea(new Dimension(0,70)));
		// Mensaje de Bienvenida
		this.add(welcome_text);
		this.add(Box.createRigidArea(new Dimension(0,60)));
		this.add(registerer_btn);
		this.add(Box.createRigidArea(new Dimension(0,100)));
		this.add(shower_btn);
		this.add(Box.createVerticalGlue());
		this.add(maker);
	}


}
