/**
* 
* @author José Rojel
* 
*	Esta clase implementa métodos que se obtienen de la API JFreeCharts,
*	genera Datasets y obtiene un ChartPanel que hereda de JPanel, este elemento
*	 se agregará al panel de visualización ShowerPanel.
*	
*/

import java.awt.*;
import java.awt.geom.Ellipse2D;
import java.io.IOException;

import javax.swing.JComboBox;
import org.jfree.chart.*;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.category.LineAndShapeRenderer;
import org.jfree.data.category.DefaultCategoryDataset;

public class Plotter {

	private static final long serialVersionUID = 1L;
	final static String REGISTERFILE = "./registros.csv";
	
	public Plotter() {

	}
	
	public ChartPanel getChart(int datos_, JComboBox selection) throws NumberFormatException, IOException {
		DefaultCategoryDataset dataset = getData(datos_,selection);
		JFreeChart lineChart = ChartFactory.createLineChart(
		         (String)selection.getSelectedItem(),
		         "","",
		         dataset,
		         PlotOrientation.VERTICAL,
		         false,true,false);
		ChartPanel chartPanel = new ChartPanel( lineChart );
		chartPanel.setPreferredSize( new java.awt.Dimension( 300 , 450 ) );
		CategoryPlot plot = (CategoryPlot) lineChart.getPlot();
		NumberAxis rangeAxis = (NumberAxis) plot.getRangeAxis();
		rangeAxis.setStandardTickUnits(NumberAxis.createIntegerTickUnits());
		LineAndShapeRenderer renderer = (LineAndShapeRenderer) plot.getRenderer();
		renderer.setBaseShapesVisible(true);
		renderer.setDrawOutlines(true);
		renderer.setSeriesPaint( 0 , Color.BLUE);
		renderer.setUseFillPaint(true);
		renderer.setBaseFillPaint(Color.white);
		renderer.setSeriesStroke(0, new BasicStroke(1.0f));
		renderer.setSeriesOutlineStroke(0, new BasicStroke(6.0f));
		renderer.setSeriesShape(0, new Ellipse2D.Double(-2.0, -2.0, 3.0, 3.0));
		chartPanel.repaint();
		
		return chartPanel;
	}
	
	private DefaultCategoryDataset getData(int data_, JComboBox selection) throws NumberFormatException, IOException {
		CSVReader reader = new CSVReader(REGISTERFILE);
		int index = selection.getSelectedIndex() + 1; //El 0 es nuestro 1 en el CSV.
		DefaultCategoryDataset dataset = new DefaultCategoryDataset( );
		for(int i=data_-1;i>=0;i--) {
			dataset.addValue(Integer.parseInt(reader.getRecord(reader.lineNumbers()-i)[index])
							, (String) selection.getSelectedItem()
							, reader.getRecord(reader.lineNumbers()-i)[0]);
		}
		return  dataset;
	}
}
