/**
* 
* @author José Rojel
* 
*	ShowerPanel es administrada por el Administrador, este se encarga de refrescar los 
*	elementos de esta clase que hereda de JPanel, además esta clase se encarga de mostrar 
*	el visualizador.
*	
*/

import java.awt.CardLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JPanel;

import org.jfree.chart.*;


public class ShowerPanel extends JPanel {
	
	private Plotter plotter;
	private ChartPanel chart;
	private JComboBox select_var;
	private Administrador admin;
	private JPanel bottom_panel;
	private JButton back_btn;
	private int num_data;
	
	public ShowerPanel(JPanel cards) throws NumberFormatException, IOException {
		
		num_data = 5;
		// Seteo del Panel Inferior de 4 elementos seguidos.
		bottom_panel = new JPanel();
		bottom_panel.setLayout(new BoxLayout(bottom_panel, BoxLayout.X_AXIS));
		
		JButton datos_5 = new JButton("5 Datos");
		datos_5.setFont(new Font("Dialog", Font.BOLD, 10));
		datos_5.setPreferredSize(new Dimension(90,20));
		datos_5.setMinimumSize(new Dimension(90, 20));
		datos_5.setMaximumSize(new Dimension(90, 20));
		datos_5.setAlignmentY(Component.CENTER_ALIGNMENT);
		datos_5.addActionListener(new ActionListener() {

	        @Override
	        public void actionPerformed(ActionEvent arg0) {
	        	try {
					updateDatato5();
				} catch (NumberFormatException | IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	        	try {
					updateShower();
				} catch (NumberFormatException | IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	        }
	    });
		
		JButton datos_10 = new JButton("10 Datos");
		datos_10.setFont(new Font("Dialog", Font.BOLD, 10));
		datos_10.setPreferredSize(new Dimension(90,20));
		datos_10.setMinimumSize(new Dimension(90, 20));
		datos_10.setMaximumSize(new Dimension(90, 20));
		datos_10.setAlignmentY(Component.CENTER_ALIGNMENT);
		datos_10.addActionListener(new ActionListener() {

	        @Override
	        public void actionPerformed(ActionEvent arg0) {
	        	try {
					updateDatato10();
				} catch (NumberFormatException | IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	        	try {
					updateShower();
				} catch (NumberFormatException | IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	        }
	    });
		// Panel de Abajo
		bottom_panel.add(Box.createRigidArea(new Dimension(30,0)));
		bottom_panel.add(datos_5);
		bottom_panel.add(Box.createRigidArea(new Dimension(60,0)));
		bottom_panel.add(datos_10);
		bottom_panel.add(Box.createRigidArea(new Dimension(30,0)));
		bottom_panel.setAlignmentX(Component.CENTER_ALIGNMENT);
		//
		
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		CardLayout card_changer = (CardLayout)(cards.getLayout());
		
		
		select_var = new JComboBox();
		select_var.setFont(new Font("Dialog", Font.PLAIN, 10));
		select_var.setModel(new DefaultComboBoxModel(new String[] {"Kilómetros [km]", "Combustible [$]", "Pasajeros [#]", "Percepción"}));
		select_var.setSelectedIndex(0);
		select_var.setPreferredSize(new Dimension(130,15));
		select_var.setMinimumSize(new Dimension(130, 15));
		select_var.setMaximumSize(new Dimension(130, 15));
		select_var.setAlignmentX(Component.CENTER_ALIGNMENT);
		select_var.addActionListener(new ActionListener() {

	        @Override
	        public void actionPerformed(ActionEvent arg0) {
	        	try {
					updateVariable();
				} catch (NumberFormatException | IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	        	try {
					updateShower();
				} catch (NumberFormatException | IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	        }
	    });
		
		
		
		
		back_btn = new JButton("Back");
		back_btn.setFont(new Font("Dialog", Font.PLAIN, 10));
		back_btn.setAlignmentX(Component.CENTER_ALIGNMENT);
		back_btn.setPreferredSize(new Dimension(60,20));
		back_btn.setMinimumSize(new Dimension(60, 20));
		back_btn.setMaximumSize(new Dimension(60, 20));
		
		back_btn.addActionListener(new ActionListener() {

	        @Override
	        public void actionPerformed(ActionEvent arg0) {
	        	card_changer.show(cards, "Panel de Entrada");
			}
	    });
		
		plotter = new Plotter();
		chart = plotter.getChart(num_data,select_var);
		
		this.add(chart);
		this.add(Box.createVerticalGlue());
		this.add(select_var);
		this.add(Box.createRigidArea(new Dimension(0,5)));
		this.add(bottom_panel);
		this.add(Box.createRigidArea(new Dimension(0,10)));
		this.add(back_btn);
		this.add(Box.createRigidArea(new Dimension(0,10)));
		
//		ChartPanel chart = plotter.getChart();
		
	}
	
	public void updateData() throws NumberFormatException, IOException {
		num_data = 5;
		chart = plotter.getChart(num_data,select_var);
	}
	
	public void updateDatato5() throws NumberFormatException, IOException {
		num_data = 5;
		chart = plotter.getChart(num_data,select_var);
	}
	
	public void updateDatato10() throws NumberFormatException, IOException {
		num_data = 10;
		chart = plotter.getChart(num_data,select_var);
	}
	
	public void updateVariable() throws NumberFormatException, IOException {
		chart = plotter.getChart(num_data,select_var);
	}
	
	public void updateShower() throws NumberFormatException, IOException {
		this.removeAll();
		this.revalidate(); // This removes the old chart
		this.add(chart);
		this.add(Box.createVerticalGlue());
		this.add(select_var);
		this.add(Box.createRigidArea(new Dimension(0,5)));
		this.add(bottom_panel);
		this.add(Box.createRigidArea(new Dimension(0,10)));
		this.add(back_btn);
		this.add(Box.createRigidArea(new Dimension(0,10)));
	}
	
	public void setAdministrador(Administrador admin_) {
		admin = admin_;
	}

}
