/**
* 
* @author José Rojel
* 
*  La clase Test es la que genera el Frame principal que
*	estará activo en toda la ejecución de la aplicación.
*	Maneja 3 JPanel's con un CardLayout.
*	
*/


import java.awt.*;
import java.io.IOException;

import javax.swing.*;



public class Test {

	private JFrame frame;
	JPanel cards;
	final static String OPENPANEL = "Panel de Entrada";
	final static String REGISTERPANEL = "Panel de Registro";
	final static String SHOWERPANEL = "Panel de Gráficos";
	final static String REGISTERFILE = "./registros.csv";

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					CSVWriter writer = new CSVWriter(REGISTERFILE);
					writer.makeFile();
					Test window = new Test();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 * @throws IOException 
	 * @throws NumberFormatException 
	 */
	public Test() throws NumberFormatException, IOException {
	initialize();
	}


	private void initialize() throws NumberFormatException, IOException {
		frame = new JFrame();
		JPanel pane1 = new JPanel();
		frame.setBounds(100, 100, 300, 450);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		cards = new JPanel(new CardLayout());
		CardLayout cl = (CardLayout)(cards.getLayout());
		
		OpeningPanel panel1 = new OpeningPanel(cards);
		RegistererPanel panel2 = new RegistererPanel(cards);
		ShowerPanel panel3 = new ShowerPanel(cards); 
		
		Administrador admin = new Administrador(panel2,panel3);
		panel2.setAdministrador(admin);
		panel3.setAdministrador(admin);
		
		cards.add(panel1, OPENPANEL);
		cards.add(panel2, REGISTERPANEL);
		cards.add(panel3, SHOWERPANEL);
		
        //Display the window.
        //frame.pack();
		frame.getContentPane().add(cards, BorderLayout.CENTER);
        frame.setVisible(true);
	}

}
